local displayDistance = 500.0
local isAdmin = false
local userIdMap = {}
local playerBlips = {}

RegisterNetEvent("playerblips:setAdmin", function(state)
    isAdmin = state

    if not state then
        for serverId, blip in pairs(playerBlips) do
            if DoesBlipExist(blip) then
                RemoveBlip(blip)
            end
        end
        playerBlips = {}
    end
end)

RegisterNetEvent("playerblips:receiveUserId", function(targetSource, user_id)
    userIdMap[targetSource] = user_id
end)

RegisterCommand('blips', function()
    TriggerServerEvent('vRP:Blips')
end)

Citizen.CreateThread(function()
    while true do
        Citizen.Wait(0)
        if not isAdmin then
            Citizen.Wait(1000)
            goto continue
        end

        local players = GetActivePlayers()
        local myPed = PlayerPedId()
        local myCoords = GetEntityCoords(myPed)

        for _, playerId in ipairs(players) do
            if playerId ~= PlayerId() then
                local ped = GetPlayerPed(playerId)
                local coords = GetEntityCoords(ped)
                local dist = #(coords - myCoords)
                local serverId = GetPlayerServerId(playerId)

                if not userIdMap[serverId] then
                    TriggerServerEvent("playerblips:requestUserId", serverId)
                end

                if dist < displayDistance then
                    if not playerBlips[serverId] then
                        local blip = AddBlipForEntity(ped)
                        SetBlipSprite(blip, 1)
                        SetBlipColour(blip, 29)
                        SetBlipScale(blip, 0.85)
                        SetBlipCategory(blip, 7)
                        BeginTextCommandSetBlipName("STRING")
                        AddTextComponentString("Jucător [" .. (userIdMap[serverId] or "?") .. "]")
                        EndTextCommandSetBlipName(blip)
                        playerBlips[serverId] = blip
                    else
                        local blip = playerBlips[serverId]
                        if DoesBlipExist(blip) then
                            SetBlipCoords(blip, coords)
                        end
                    end
                else
                    if playerBlips[serverId] then
                        local blip = playerBlips[serverId]
                        if DoesBlipExist(blip) then
                            RemoveBlip(blip)
                        end
                        playerBlips[serverId] = nil
                    end
                end

                local name = GetPlayerName(playerId)
                local health = math.floor((GetEntityHealth(ped) - 100))
                local armor = GetPedArmour(ped)
                local user_id = userIdMap[serverId] or "?"
                DrawText3D(coords.x, coords.y, coords.z + 1.1, user_id, name, health, armor, dist)
            end
        end

        ::continue::
    end
end)

function DrawText3D(x, y, z, user_id, name, health, armor, distance)
    local onScreen, _x, _y = World3dToScreen2d(x, y, z)
    local p = GetGameplayCamCoords()
    local dist = #(vector3(x, y, z) - p)

    local scale = 0.45 / dist * 2.0
    scale = scale * (1.0 / GetGameplayCamFov()) * 100

    if onScreen then
        SetTextFont(4)
        SetTextProportional(1)
        SetTextScale(0.3, 0.3)
        SetTextColour(255, 255, 255, 255)
        SetTextCentre(true)
        SetTextOutline()
        SetTextEntry("STRING")
        AddTextComponentString(string.format("~b~%s [ID: %s] ~w~| ~r~ %d ~w~| ~b~ %d ~w~| ~y~%.1fm", name, user_id, health, armor, distance))
        DrawText(_x, _y)
    end
end
